// Mesure et affichage de la température et de l'humidité relative d'un capteur SHT20/21
// Calcul et affichage du point de rosée.
//

#include <Wire.h>

void setup()
{
    Wire.begin();
//  Wire.begin(21,22,100000);

  Serial.begin(9600);
  Serial.println("Mesures SHT20/SHT21");
  Serial.println(" ");
}


void loop()
{
//  byte error, address;
//  int nDevices;
byte data[2];
int ST, SRH;
float mesureT, mesureRH;
float alpha, Tr;

// Mesure de la température
Wire.beginTransmission(0x40);
Wire.write(0xF3);
Wire.endTransmission();
delay(100);
Wire.requestFrom(0x40,2);
while(Wire.available() < 2) {}
  data[0] = Wire.read();  // read data (MSB)
  data[1] = Wire.read();  // read data (LSB)
/*Serial.print("Data 0 : ");
Serial.println(data[0]);
Serial.print("Data 1 : ");
Serial.println(data[1]);*/
  
ST = (int)data[0]*256 + (int)(data[1]&0b11111100);// Signal Temperature
/*Serial.print("ST : ");
Serial.println(ST);*/
mesureT= (-46.85 +175.72 * ST/65536);
Serial.print("Température : ");
Serial.print(mesureT);
Serial.println(" °C");

// Mesure de la l'humidité relative
Wire.beginTransmission(0x40);
Wire.write(0xF5);
Wire.endTransmission();
delay(100);
Wire.requestFrom(0x40,2);
while(Wire.available() < 2) {}
  data[0] = Wire.read();  // read data (MSB)
  data[1] = Wire.read();  // read data (LSB)
/*Serial.print("Data 0 : ");
Serial.println(data[0]);
Serial.print("Data 1 : ");
Serial.println(data[1]);*/
  
SRH = (int)data[0]*256 + (int)(data[1]&0b11110000);// Signal Humidité Relative
/*Serial.print("SRH : ");
Serial.println(SRH);*/
mesureRH= (-6.00 +125.00 * SRH/65536);
Serial.print("Humidité relative : ");
Serial.print(mesureRH);
Serial.println(" %");

// Calcul du point de rosée
alpha=(17.27*mesureT)/(237.7+mesureT)+log(mesureRH/100);
Tr = (237.7*alpha)/(17.27-alpha);
Serial.print("Point de rosée : ");
Serial.print(Tr);
Serial.println(" °C");
Serial.println(" ");

delay(5000);           // 
}
